/*
    This file is part of gencon - a configuration file reader generator.
    Copyright (C) 2012 Sukru Cinar

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

enum { type_int, type_float, type_string, type_array, type_record };

typedef struct type {
   int kind;
   void *arg;
} type_t;

typedef struct cst {
  struct cst *next;
  char *name, *value;
  type_t *type;
} cst_t;


typedef struct cfield
{
  struct cfield *next;
  char *name;
  type_t *type;
  cst_t *cst;
  int table_number;
} cfield_t;

typedef struct cstruct {
  struct cstruct *next;
  char *name;
  cfield_t *fields;
  int table_number;
} cstruct_t;

extern char *code_file_name, *header_file_name,
             *header_text, *footer_text;
extern cstruct_t *top_level_structs;
extern cstruct_t *structs;
extern cst_t *top_level_consts;
