/*
    This file is part of gencon - a configuration file reader generator.
    Copyright (C) 2012 Sukru Cinar

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

char *lib_header= 
"#include <stdlib.h>\n"
"#include <stdarg.h>\n"
"#include <setjmp.h>\n"
"#include <stddef.h>\n"
"#include <stdio.h>\n"
"\n"
"typedef struct {\n"
"  char *name;\n"
"  int kind;\n"
"  int offset, soffset, noffset, goffset;\n"
"  void *arg;\n"
"  int eltsize;\n"
"} cfgl_field_t;\n"
"typedef struct { char *name; int value; } cfgl_intcst_t;\n"
"typedef struct { char *name; char *value; } cfgl_strcst_t;\n"
"typedef struct { char *name; double value; } cfgl_flocst_t;\n"
"\n"
"\n"
"static char cfgl_ebuf[2000];\n"
"static jmp_buf cfgl_elabel;\n"
"static char *cfgl_fname;\n"
"static int spaces;\n"
"\n"
"\n"
"\n"
"static int token;\n"
"static char *sbuf;\n"
"static int ssize= 100, slen;\n"
"static int ivalue;\n"
"static double fvalue;\n"
"\n"
"\n"
"static char* cfgl_parse_top(char *fn,void *ptr, cfgl_field_t *fields);\n"
"static void cfgl_parse_struct(void *ptr, cfgl_field_t *fields);\n"
"static void cfgl_parse_field(void *ptr, cfgl_field_t *fields);\n"
"static void cfgl_parse_int(int *ptr, char *given, cfgl_intcst_t *cst);\n"
"static void cfgl_lookup_int(cfgl_intcst_t *cst, int *ptr);\n"
"static void cfgl_lookup_flo(cfgl_flocst_t *cst, double *ptr);\n"
"static void cfgl_lookup_str(cfgl_strcst_t *cst, char **ptr);\n"
"static void cfgl_parse_intarray\n"
"   (int **ptr, int *size, int *len, cfgl_intcst_t *cst);\n"
"static void cfgl_put_int\n"
"  (int **ptr, int *size, int *len, cfgl_intcst_t *cst);\n"
"static void* cfgl_array_grow(void *ptr, int *size, int *len, int esize);\n"
"static void cfgl_parse_recarray\n"
"    (void **ptr, int *size, int *len, int esize, cfgl_field_t *fields);\n"
"static void cfgl_parse_flo(double *ptr, char *given, cfgl_flocst_t *cst);\n"
"static void cfgl_parse_floarray\n"
"   (double **ptr, int *size, int *len, cfgl_flocst_t *cst);\n"
"static void cfgl_put_flo\n"
"  (double **ptr, int *size, int *len, cfgl_flocst_t *cst);\n"
"static void cfgl_parse_str(char** ptr, char *given, cfgl_strcst_t *cst);\n"
"static void cfgl_parse_strarray\n"
"   (char ***ptr, int *size, int *len, cfgl_strcst_t *cst);\n"
"static void cfgl_put_str\n"
"  (char ***ptr, int *size, int *len, cfgl_strcst_t *cst);\n"
"static void cfgl_error(char *fmt, ...);\n"
"static void sreset() ;\n"
"static void sput(int x) ;\n"
"static char* cfgl_write_top(char *fn,void *ptr, cfgl_field_t *fields);\n"
"static void cfgl_write_field(FILE *out, void *ptr, cfgl_field_t *field);\n"
"static int has_valid_fields(void *ptr, cfgl_field_t* field);\n"
"static void cfgl_write_struct(FILE *f, void *ptr, cfgl_field_t *field);\n"
"static void cfgl_write_str(FILE *f, char *str);\n"
"static void print_spaces(FILE *out);\n"

  ;

char *lib_footer= 

"/*** THIS IS THE FLEX START ***/\n"
"\n"
"\n"
"#define  YY_INT_ALIGNED short int\n"
"\n"
"/* A lexical scanner generated by flex */\n"
"\n"
"#define yy_create_buffer cfgl__create_buffer\n"
"#define yy_delete_buffer cfgl__delete_buffer\n"
"#define yy_flex_debug cfgl__flex_debug\n"
"#define yy_init_buffer cfgl__init_buffer\n"
"#define yy_flush_buffer cfgl__flush_buffer\n"
"#define yy_load_buffer_state cfgl__load_buffer_state\n"
"#define yy_switch_to_buffer cfgl__switch_to_buffer\n"
"#define yyin cfgl_in\n"
"#define yyleng cfgl_leng\n"
"#define yylex cfgl_lex\n"
"#define yylineno cfgl_lineno\n"
"#define yyout cfgl_out\n"
"#define yyrestart cfgl_restart\n"
"#define yytext cfgl_text\n"
"#define yywrap cfgl_wrap\n"
"#define yyalloc cfgl_alloc\n"
"#define yyrealloc cfgl_realloc\n"
"#define yyfree cfgl_free\n"
"\n"
"#define FLEX_SCANNER\n"
"#define YY_FLEX_MAJOR_VERSION 2\n"
"#define YY_FLEX_MINOR_VERSION 5\n"
"#define YY_FLEX_SUBMINOR_VERSION 37\n"
"#if YY_FLEX_SUBMINOR_VERSION > 0\n"
"#define FLEX_BETA\n"
"#endif\n"
"\n"
"/* First, we deal with  platform-specific or compiler-specific issues. */\n"
"\n"
"/* begin standard C headers. */\n"
"#include <stdio.h>\n"
"#include <string.h>\n"
"#include <errno.h>\n"
"#include <stdlib.h>\n"
"\n"
"/* end standard C headers. */\n"
"\n"
"/* flex integer type definitions */\n"
"\n"
"#ifndef FLEXINT_H\n"
"#define FLEXINT_H\n"
"\n"
"/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */\n"
"\n"
"#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L\n"
"\n"
"/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,\n"
" * if you want the limit (max/min) macros for int types. \n"
" */\n"
"#ifndef __STDC_LIMIT_MACROS\n"
"#define __STDC_LIMIT_MACROS 1\n"
"#endif\n"
"\n"
"#include <inttypes.h>\n"
"typedef int8_t flex_int8_t;\n"
"typedef uint8_t flex_uint8_t;\n"
"typedef int16_t flex_int16_t;\n"
"typedef uint16_t flex_uint16_t;\n"
"typedef int32_t flex_int32_t;\n"
"typedef uint32_t flex_uint32_t;\n"
"#else\n"
"typedef signed char flex_int8_t;\n"
"typedef short int flex_int16_t;\n"
"typedef int flex_int32_t;\n"
"typedef unsigned char flex_uint8_t; \n"
"typedef unsigned short int flex_uint16_t;\n"
"typedef unsigned int flex_uint32_t;\n"
"\n"
"/* Limits of integral types. */\n"
"#ifndef INT8_MIN\n"
"#define INT8_MIN               (-128)\n"
"#endif\n"
"#ifndef INT16_MIN\n"
"#define INT16_MIN              (-32767-1)\n"
"#endif\n"
"#ifndef INT32_MIN\n"
"#define INT32_MIN              (-2147483647-1)\n"
"#endif\n"
"#ifndef INT8_MAX\n"
"#define INT8_MAX               (127)\n"
"#endif\n"
"#ifndef INT16_MAX\n"
"#define INT16_MAX              (32767)\n"
"#endif\n"
"#ifndef INT32_MAX\n"
"#define INT32_MAX              (2147483647)\n"
"#endif\n"
"#ifndef UINT8_MAX\n"
"#define UINT8_MAX              (255U)\n"
"#endif\n"
"#ifndef UINT16_MAX\n"
"#define UINT16_MAX             (65535U)\n"
"#endif\n"
"#ifndef UINT32_MAX\n"
"#define UINT32_MAX             (4294967295U)\n"
"#endif\n"
"\n"
"#endif /* ! C99 */\n"
"\n"
"#endif /* ! FLEXINT_H */\n"
"\n"
"#ifdef __cplusplus\n"
"\n"
"/* The \042const\042 storage-class-modifier is valid. */\n"
"#define YY_USE_CONST\n"
"\n"
"#else\011/* ! __cplusplus */\n"
"\n"
"/* C99 requires __STDC__ to be defined as 1. */\n"
"#if defined (__STDC__)\n"
"\n"
"#define YY_USE_CONST\n"
"\n"
"#endif\011/* defined (__STDC__) */\n"
"#endif\011/* ! __cplusplus */\n"
"\n"
"#ifdef YY_USE_CONST\n"
"#define yyconst const\n"
"#else\n"
"#define yyconst\n"
"#endif\n"
"\n"
"/* Returned upon end-of-file. */\n"
"#define YY_NULL 0\n"
"\n"
"/* Promotes a possibly negative, possibly signed char to an unsigned\n"
" * integer for use as an array index.  If the signed char is negative,\n"
" * we want to instead treat it as an 8-bit unsigned char, hence the\n"
" * double cast.\n"
" */\n"
"#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)\n"
"\n"
"/* Enter a start condition.  This macro really ought to take a parameter,\n"
" * but we do it the disgusting crufty way forced on us by the ()-less\n"
" * definition of BEGIN.\n"
" */\n"
"#define BEGIN (yy_start) = 1 + 2 *\n"
"\n"
"/* Translate the current start state into a value that can be later handed\n"
" * to BEGIN to return to the state.  The YYSTATE alias is for lex\n"
" * compatibility.\n"
" */\n"
"#define YY_START (((yy_start) - 1) / 2)\n"
"#define YYSTATE YY_START\n"
"\n"
"/* Action number for EOF rule of a given start state. */\n"
"#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)\n"
"\n"
"/* Special action meaning \042start processing a new file\042. */\n"
"#define YY_NEW_FILE cfgl_restart(cfgl_in  )\n"
"\n"
"#define YY_END_OF_BUFFER_CHAR 0\n"
"\n"
"/* Size of default input buffer. */\n"
"#ifndef YY_BUF_SIZE\n"
"#define YY_BUF_SIZE 16384\n"
"#endif\n"
"\n"
"/* The state buf must be large enough to hold one state per character in the main buffer.\n"
" */\n"
"#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))\n"
"\n"
"#ifndef YY_TYPEDEF_YY_BUFFER_STATE\n"
"#define YY_TYPEDEF_YY_BUFFER_STATE\n"
"typedef struct yy_buffer_state *YY_BUFFER_STATE;\n"
"#endif\n"
"\n"
"#ifndef YY_TYPEDEF_YY_SIZE_T\n"
"#define YY_TYPEDEF_YY_SIZE_T\n"
"typedef size_t yy_size_t;\n"
"#endif\n"
"\n"
"extern yy_size_t cfgl_leng;\n"
"\n"
"extern FILE *cfgl_in, *cfgl_out;\n"
"\n"
"#define EOB_ACT_CONTINUE_SCAN 0\n"
"#define EOB_ACT_END_OF_FILE 1\n"
"#define EOB_ACT_LAST_MATCH 2\n"
"\n"
"    /* Note: We specifically omit the test for yy_rule_can_match_eol because it requires\n"
"     *       access to the local variable yy_act. Since yyless() is a macro, it would break\n"
"     *       existing scanners that call yyless() from OUTSIDE cfgl_lex. \n"
"     *       One obvious solution it to make yy_act a global. I tried that, and saw\n"
"     *       a 5% performance hit in a non-cfgl_lineno scanner, because yy_act is\n"
"     *       normally declared as a register variable-- so it is not worth it.\n"
"     */\n"
"    #define  YY_LESS_LINENO(n) \134\n"
"            do { \134\n"
"                int yyl;\134\n"
"                for ( yyl = n; yyl < cfgl_leng; ++yyl )\134\n"
"                    if ( cfgl_text[yyl] == \047\134n\047 )\134\n"
"                        --cfgl_lineno;\134\n"
"            }while(0)\n"
"    \n"
"/* Return all but the first \042n\042 matched characters back to the input stream. */\n"
"#define yyless(n) \134\n"
"\011do \134\n"
"\011\011{ \134\n"
"\011\011/* Undo effects of setting up cfgl_text. */ \134\n"
"        int yyless_macro_arg = (n); \134\n"
"        YY_LESS_LINENO(yyless_macro_arg);\134\n"
"\011\011*yy_cp = (yy_hold_char); \134\n"
"\011\011YY_RESTORE_YY_MORE_OFFSET \134\n"
"\011\011(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \134\n"
"\011\011YY_DO_BEFORE_ACTION; /* set up cfgl_text again */ \134\n"
"\011\011} \134\n"
"\011while ( 0 )\n"
"\n"
"#define unput(c) yyunput( c, (yytext_ptr)  )\n"
"\n"
"#ifndef YY_STRUCT_YY_BUFFER_STATE\n"
"#define YY_STRUCT_YY_BUFFER_STATE\n"
"struct yy_buffer_state\n"
"\011{\n"
"\011FILE *yy_input_file;\n"
"\n"
"\011char *yy_ch_buf;\011\011/* input buffer */\n"
"\011char *yy_buf_pos;\011\011/* current position in input buffer */\n"
"\n"
"\011/* Size of input buffer in bytes, not including room for EOB\n"
"\011 * characters.\n"
"\011 */\n"
"\011yy_size_t yy_buf_size;\n"
"\n"
"\011/* Number of characters read into yy_ch_buf, not including EOB\n"
"\011 * characters.\n"
"\011 */\n"
"\011yy_size_t yy_n_chars;\n"
"\n"
"\011/* Whether we \042own\042 the buffer - i.e., we know we created it,\n"
"\011 * and can realloc() it to grow it, and should free() it to\n"
"\011 * delete it.\n"
"\011 */\n"
"\011int yy_is_our_buffer;\n"
"\n"
"\011/* Whether this is an \042interactive\042 input source; if so, and\n"
"\011 * if we\047re using stdio for input, then we want to use getc()\n"
"\011 * instead of fread(), to make sure we stop fetching input after\n"
"\011 * each newline.\n"
"\011 */\n"
"\011int yy_is_interactive;\n"
"\n"
"\011/* Whether we\047re considered to be at the beginning of a line.\n"
"\011 * If so, \047^\047 rules will be active on the next match, otherwise\n"
"\011 * not.\n"
"\011 */\n"
"\011int yy_at_bol;\n"
"\n"
"    int yy_bs_lineno; /**< The line count. */\n"
"    int yy_bs_column; /**< The column count. */\n"
"    \n"
"\011/* Whether to try to fill the input buffer when we reach the\n"
"\011 * end of it.\n"
"\011 */\n"
"\011int yy_fill_buffer;\n"
"\n"
"\011int yy_buffer_status;\n"
"\n"
"#define YY_BUFFER_NEW 0\n"
"#define YY_BUFFER_NORMAL 1\n"
"\011/* When an EOF\047s been seen but there\047s still some text to process\n"
"\011 * then we mark the buffer as YY_EOF_PENDING, to indicate that we\n"
"\011 * shouldn\047t try reading from the input source any more.  We might\n"
"\011 * still have a bunch of tokens to match, though, because of\n"
"\011 * possible backing-up.\n"
"\011 *\n"
"\011 * When we actually see the EOF, we change the status to \042new\042\n"
"\011 * (via cfgl_restart()), so that the user can continue scanning by\n"
"\011 * just pointing cfgl_in at a new input file.\n"
"\011 */\n"
"#define YY_BUFFER_EOF_PENDING 2\n"
"\n"
"\011};\n"
"#endif /* !YY_STRUCT_YY_BUFFER_STATE */\n"
"\n"
"/* Stack of input buffers. */\n"
"static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */\n"
"static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */\n"
"static YY_BUFFER_STATE * yy_buffer_stack = 0; /**< Stack as an array. */\n"
"\n"
"/* We provide macros for accessing buffer states in case in the\n"
" * future we want to put the buffer states in a more general\n"
" * \042scanner state\042.\n"
" *\n"
" * Returns the top of the stack, or NULL.\n"
" */\n"
"#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \134\n"
"                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \134\n"
"                          : NULL)\n"
"\n"
"/* Same as previous macro, but useful when we know that the buffer stack is not\n"
" * NULL or when we need an lvalue. For internal use only.\n"
" */\n"
"#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]\n"
"\n"
"/* yy_hold_char holds the character lost when cfgl_text is formed. */\n"
"static char yy_hold_char;\n"
"static yy_size_t yy_n_chars;\011\011/* number of characters read into yy_ch_buf */\n"
"yy_size_t cfgl_leng;\n"
"\n"
"/* Points to current character in buffer. */\n"
"static char *yy_c_buf_p = (char *) 0;\n"
"static int yy_init = 0;\011\011/* whether we need to initialize */\n"
"static int yy_start = 0;\011/* start state number */\n"
"\n"
"/* Flag which is used to allow cfgl_wrap()\047s to do buffer switches\n"
" * instead of setting up a fresh cfgl_in.  A bit of a hack ...\n"
" */\n"
"static int yy_did_buffer_switch_on_eof;\n"
"\n"
"void cfgl_restart (FILE *input_file  );\n"
"void cfgl__switch_to_buffer (YY_BUFFER_STATE new_buffer  );\n"
"YY_BUFFER_STATE cfgl__create_buffer (FILE *file,int size  );\n"
"void cfgl__delete_buffer (YY_BUFFER_STATE b  );\n"
"void cfgl__flush_buffer (YY_BUFFER_STATE b  );\n"
"void cfgl_push_buffer_state (YY_BUFFER_STATE new_buffer  );\n"
"void cfgl_pop_buffer_state (void );\n"
"\n"
"static void cfgl_ensure_buffer_stack (void );\n"
"static void cfgl__load_buffer_state (void );\n"
"static void cfgl__init_buffer (YY_BUFFER_STATE b,FILE *file  );\n"
"\n"
"#define YY_FLUSH_BUFFER cfgl__flush_buffer(YY_CURRENT_BUFFER )\n"
"\n"
"YY_BUFFER_STATE cfgl__scan_buffer (char *base,yy_size_t size  );\n"
"YY_BUFFER_STATE cfgl__scan_string (yyconst char *yy_str  );\n"
"YY_BUFFER_STATE cfgl__scan_bytes (yyconst char *bytes,yy_size_t len  );\n"
"\n"
"void *cfgl_alloc (yy_size_t  );\n"
"void *cfgl_realloc (void *,yy_size_t  );\n"
"void cfgl_free (void *  );\n"
"\n"
"#define yy_new_buffer cfgl__create_buffer\n"
"\n"
"#define yy_set_interactive(is_interactive) \134\n"
"\011{ \134\n"
"\011if ( ! YY_CURRENT_BUFFER ){ \134\n"
"        cfgl_ensure_buffer_stack (); \134\n"
"\011\011YY_CURRENT_BUFFER_LVALUE =    \134\n"
"            cfgl__create_buffer(cfgl_in,YY_BUF_SIZE ); \134\n"
"\011} \134\n"
"\011YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \134\n"
"\011}\n"
"\n"
"#define yy_set_bol(at_bol) \134\n"
"\011{ \134\n"
"\011if ( ! YY_CURRENT_BUFFER ){\134\n"
"        cfgl_ensure_buffer_stack (); \134\n"
"\011\011YY_CURRENT_BUFFER_LVALUE =    \134\n"
"            cfgl__create_buffer(cfgl_in,YY_BUF_SIZE ); \134\n"
"\011} \134\n"
"\011YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \134\n"
"\011}\n"
"\n"
"#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)\n"
"\n"
"/* Begin user sect3 */\n"
"\n"
"#define cfgl_wrap() 1\n"
"#define YY_SKIP_YYWRAP\n"
"\n"
"typedef unsigned char YY_CHAR;\n"
"\n"
"FILE *cfgl_in = (FILE *) 0, *cfgl_out = (FILE *) 0;\n"
"\n"
"typedef int yy_state_type;\n"
"\n"
"extern int cfgl_lineno;\n"
"\n"
"int cfgl_lineno = 1;\n"
"\n"
"extern char *cfgl_text;\n"
"#define yytext_ptr cfgl_text\n"
"\n"
"static yy_state_type yy_get_previous_state (void );\n"
"static yy_state_type yy_try_NUL_trans (yy_state_type current_state  );\n"
"static int yy_get_next_buffer (void );\n"
"static void yy_fatal_error (yyconst char msg[]  );\n"
"\n"
"/* Done after the current pattern has been matched and before the\n"
" * corresponding action - sets up cfgl_text.\n"
" */\n"
"#define YY_DO_BEFORE_ACTION \134\n"
"\011(yytext_ptr) = yy_bp; \134\n"
"\011cfgl_leng = (size_t) (yy_cp - yy_bp); \134\n"
"\011(yy_hold_char) = *yy_cp; \134\n"
"\011*yy_cp = \047\1340\047; \134\n"
"\011(yy_c_buf_p) = yy_cp;\n"
"\n"
"#define YY_NUM_RULES 24\n"
"#define YY_END_OF_BUFFER 25\n"
"/* This struct is not used in this scanner,\n"
"   but its presence is necessary. */\n"
"struct yy_trans_info\n"
"\011{\n"
"\011flex_int32_t yy_verify;\n"
"\011flex_int32_t yy_nxt;\n"
"\011};\n"
"static yyconst flex_int16_t yy_accept[50] =\n"
"    {   0,\n"
"        0,    0,    0,    0,    0,    0,   25,    1,    1,   23,\n"
"        2,    4,    3,   23,    9,    9,    7,    5,    6,   22,\n"
"       24,   11,   22,   12,    1,    4,    9,    0,    9,    0,\n"
"        7,   21,   13,   14,   15,   16,   17,   18,   19,   21,\n"
"        9,    8,   10,    0,    0,   20,    0,    8,    0\n"
"    } ;\n"
"\n"
"static yyconst flex_int32_t yy_ec[256] =\n"
"    {   0,\n"
"        1,    1,    1,    1,    1,    1,    1,    1,    1,    2,\n"
"        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,\n"
"        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,\n"
"        1,    1,    3,    4,    5,    3,    3,    3,    6,    3,\n"
"        3,    3,    7,    3,    8,    9,    3,   10,   11,   11,\n"
"       11,   11,   11,   11,   11,   11,   11,    3,    3,    3,\n"
"        3,    3,    3,    3,   12,   12,   12,   12,   13,   12,\n"
"       14,   14,   14,   14,   14,   14,   14,   14,   14,   14,\n"
"       14,   14,   14,   14,   14,   14,   14,   14,   14,   14,\n"
"        3,   15,    3,    3,   14,    3,   16,   17,   12,   12,\n"
"\n"
"       13,   18,   14,   14,   14,   14,   14,   14,   14,   19,\n"
"       14,   14,   14,   20,   14,   21,   14,   22,   14,   23,\n"
"       14,   14,   24,    3,   25,    3,    1,    3,    3,    3,\n"
"        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,\n"
"        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,\n"
"        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,\n"
"        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,\n"
"        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,\n"
"        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,\n"
"        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,\n"
"\n"
"        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,\n"
"        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,\n"
"        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,\n"
"        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,\n"
"        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,\n"
"        3,    3,    3,    3,    3\n"
"    } ;\n"
"\n"
"static yyconst flex_int32_t yy_meta[26] =\n"
"    {   0,\n"
"        1,    2,    1,    1,    1,    1,    1,    1,    1,    3,\n"
"        3,    3,    3,    4,    1,    3,    3,    3,    4,    4,\n"
"        4,    4,    4,    1,    1\n"
"    } ;\n"
"\n"
"static yyconst flex_int16_t yy_base[57] =\n"
"    {   0,\n"
"        0,    0,   24,   25,   28,   29,   95,   31,   35,   96,\n"
"       96,    0,   96,   31,   36,   39,    0,   96,   96,   96,\n"
"       96,   96,   44,   96,   50,    0,   43,   45,   59,    0,\n"
"        0,   96,   96,   96,   96,   96,   96,   96,   96,    0,\n"
"       47,   61,    0,    0,   68,   96,   67,   69,   96,   80,\n"
"       84,   86,   90,   83,   70,   35\n"
"    } ;\n"
"\n"
"static yyconst flex_int16_t yy_def[57] =\n"
"    {   0,\n"
"       49,    1,   50,   50,   50,   50,   49,   49,   49,   49,\n"
"       49,   51,   49,   49,   49,   49,   52,   49,   49,   49,\n"
"       49,   49,   53,   49,   49,   51,   49,   49,   49,   54,\n"
"       52,   49,   49,   49,   49,   49,   49,   49,   49,   55,\n"
"       49,   49,   54,   56,   49,   49,   49,   49,    0,   49,\n"
"       49,   49,   49,   49,   49,   49\n"
"    } ;\n"
"\n"
"static yyconst flex_int16_t yy_nxt[122] =\n"
"    {   0,\n"
"        8,    9,   10,   11,   12,   13,   10,   14,   10,   15,\n"
"       16,   17,   17,   17,   10,   17,   17,   17,   17,   17,\n"
"       17,   17,   17,   18,   19,   21,   21,   22,   22,   21,\n"
"       21,   25,   25,   24,   24,   25,   25,   46,   23,   23,\n"
"       27,   27,   23,   23,   28,   29,   29,   28,   29,   29,\n"
"       25,   25,   41,   41,   42,   42,   41,   41,   30,   33,\n"
"       34,   35,   36,   37,   38,   39,   40,   28,   29,   29,\n"
"       42,   42,   44,   45,   47,   47,   48,   48,   48,   48,\n"
"       20,   20,   20,   20,   26,   43,   26,   26,   31,   31,\n"
"       32,   32,   32,   32,   49,    7,   49,   49,   49,   49,\n"
"\n"
"       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,\n"
"       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,\n"
"       49\n"
"    } ;\n"
"\n"
"static yyconst flex_int16_t yy_chk[122] =\n"
"    {   0,\n"
"        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,\n"
"        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,\n"
"        1,    1,    1,    1,    1,    3,    4,    3,    4,    5,\n"
"        6,    8,    8,    5,    6,    9,    9,   56,    3,    4,\n"
"       14,   14,    5,    6,   15,   15,   15,   16,   16,   16,\n"
"       25,   25,   27,   27,   28,   28,   41,   41,   15,   23,\n"
"       23,   23,   23,   23,   23,   23,   23,   29,   29,   29,\n"
"       42,   42,   55,   42,   45,   45,   47,   47,   48,   48,\n"
"       50,   50,   50,   50,   51,   54,   51,   51,   52,   52,\n"
"       53,   53,   53,   53,    7,   49,   49,   49,   49,   49,\n"
"\n"
"       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,\n"
"       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,\n"
"       49\n"
"    } ;\n"
"\n"
"/* Table of booleans, true if rule could match eol. */\n"
"static yyconst flex_int32_t yy_rule_can_match_eol[25] =\n"
"    {   0,\n"
"1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \n"
"    0, 1, 0, 0, 0,     };\n"
"\n"
"static yy_state_type yy_last_accepting_state;\n"
"static char *yy_last_accepting_cpos;\n"
"\n"
"extern int cfgl__flex_debug;\n"
"int cfgl__flex_debug = 0;\n"
"\n"
"/* The intent behind this definition is that it\047ll catch\n"
" * any uses of REJECT which flex missed.\n"
" */\n"
"#define REJECT reject_used_but_not_detected\n"
"#define yymore() yymore_used_but_not_detected\n"
"#define YY_MORE_ADJ 0\n"
"#define YY_RESTORE_YY_MORE_OFFSET\n"
"char *cfgl_text;\n"
"#define YY_NO_INPUT 1\n"
"\n"
"#define INITIAL 0\n"
"#define dquote 1\n"
"#define squote 2\n"
"\n"
"#ifndef YY_NO_UNISTD_H\n"
"/* Special case for \042unistd.h\042, since it is non-ANSI. We include it way\n"
" * down here because we want the user\047s section 1 to have been scanned first.\n"
" * The user has a chance to override it with an option.\n"
" */\n"
"#include <unistd.h>\n"
"#endif\n"
"\n"
"#ifndef YY_EXTRA_TYPE\n"
"#define YY_EXTRA_TYPE void *\n"
"#endif\n"
"\n"
"static int yy_init_globals (void );\n"
"\n"
"/* Accessor methods to globals.\n"
"   These are made visible to non-reentrant scanners for convenience. */\n"
"\n"
"int cfgl_lex_destroy (void );\n"
"\n"
"int cfgl_get_debug (void );\n"
"\n"
"void cfgl_set_debug (int debug_flag  );\n"
"\n"
"YY_EXTRA_TYPE cfgl_get_extra (void );\n"
"\n"
"void cfgl_set_extra (YY_EXTRA_TYPE user_defined  );\n"
"\n"
"FILE *cfgl_get_in (void );\n"
"\n"
"void cfgl_set_in  (FILE * in_str  );\n"
"\n"
"FILE *cfgl_get_out (void );\n"
"\n"
"void cfgl_set_out  (FILE * out_str  );\n"
"\n"
"yy_size_t cfgl_get_leng (void );\n"
"\n"
"char *cfgl_get_text (void );\n"
"\n"
"int cfgl_get_lineno (void );\n"
"\n"
"void cfgl_set_lineno (int line_number  );\n"
"\n"
"/* Macros after this point can all be overridden by user definitions in\n"
" * section 1.\n"
" */\n"
"\n"
"#ifndef YY_SKIP_YYWRAP\n"
"#ifdef __cplusplus\n"
"extern \042C\042 int cfgl_wrap (void );\n"
"#else\n"
"extern int cfgl_wrap (void );\n"
"#endif\n"
"#endif\n"
"\n"
"#ifndef yytext_ptr\n"
"static void yy_flex_strncpy (char *,yyconst char *,int );\n"
"#endif\n"
"\n"
"#ifdef YY_NEED_STRLEN\n"
"static int yy_flex_strlen (yyconst char * );\n"
"#endif\n"
"\n"
"#ifndef YY_NO_INPUT\n"
"\n"
"#ifdef __cplusplus\n"
"static int yyinput (void );\n"
"#else\n"
"static int input (void );\n"
"#endif\n"
"\n"
"#endif\n"
"\n"
"/* Amount of stuff to slurp up with each read. */\n"
"#ifndef YY_READ_BUF_SIZE\n"
"#define YY_READ_BUF_SIZE 8192\n"
"#endif\n"
"\n"
"/* Copy whatever the last rule matched to the standard output. */\n"
"#ifndef ECHO\n"
"/* This used to be an fputs(), but since the string might contain NUL\047s,\n"
" * we now use fwrite().\n"
" */\n"
"#define ECHO do { if (fwrite( cfgl_text, cfgl_leng, 1, cfgl_out )) {} } while (0)\n"
"#endif\n"
"\n"
"/* Gets input and stuffs it into \042buf\042.  number of characters read, or YY_NULL,\n"
" * is returned in \042result\042.\n"
" */\n"
"#ifndef YY_INPUT\n"
"#define YY_INPUT(buf,result,max_size) \134\n"
"\011if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \134\n"
"\011\011{ \134\n"
"\011\011int c = \047*\047; \134\n"
"\011\011size_t n; \134\n"
"\011\011for ( n = 0; n < max_size && \134\n"
"\011\011\011     (c = getc( cfgl_in )) != EOF && c != \047\134n\047; ++n ) \134\n"
"\011\011\011buf[n] = (char) c; \134\n"
"\011\011if ( c == \047\134n\047 ) \134\n"
"\011\011\011buf[n++] = (char) c; \134\n"
"\011\011if ( c == EOF && ferror( cfgl_in ) ) \134\n"
"\011\011\011YY_FATAL_ERROR( \042input in flex scanner failed\042 ); \134\n"
"\011\011result = n; \134\n"
"\011\011} \134\n"
"\011else \134\n"
"\011\011{ \134\n"
"\011\011errno=0; \134\n"
"\011\011while ( (result = fread(buf, 1, max_size, cfgl_in))==0 && ferror(cfgl_in)) \134\n"
"\011\011\011{ \134\n"
"\011\011\011if( errno != EINTR) \134\n"
"\011\011\011\011{ \134\n"
"\011\011\011\011YY_FATAL_ERROR( \042input in flex scanner failed\042 ); \134\n"
"\011\011\011\011break; \134\n"
"\011\011\011\011} \134\n"
"\011\011\011errno=0; \134\n"
"\011\011\011clearerr(cfgl_in); \134\n"
"\011\011\011} \134\n"
"\011\011}\134\n"
"\134\n"
"\n"
"#endif\n"
"\n"
"/* No semi-colon after return; correct usage is to write \042yyterminate();\042 -\n"
" * we don\047t want an extra \047;\047 after the \042return\042 because that will cause\n"
" * some compilers to complain about unreachable statements.\n"
" */\n"
"#ifndef yyterminate\n"
"#define yyterminate() return YY_NULL\n"
"#endif\n"
"\n"
"/* Number of entries by which start-condition stack grows. */\n"
"#ifndef YY_START_STACK_INCR\n"
"#define YY_START_STACK_INCR 25\n"
"#endif\n"
"\n"
"/* Report a fatal error. */\n"
"#ifndef YY_FATAL_ERROR\n"
"#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )\n"
"#endif\n"
"\n"
"/* end tables serialization structures and prototypes */\n"
"\n"
"/* Default declaration of generated scanner - a define so the user can\n"
" * easily add parameters.\n"
" */\n"
"#ifndef YY_DECL\n"
"#define YY_DECL_IS_OURS 1\n"
"\n"
"extern int cfgl_lex (void);\n"
"\n"
"#define YY_DECL int cfgl_lex (void)\n"
"#endif /* !YY_DECL */\n"
"\n"
"/* Code executed at the beginning of each rule, after cfgl_text and cfgl_leng\n"
" * have been set up.\n"
" */\n"
"#ifndef YY_USER_ACTION\n"
"#define YY_USER_ACTION\n"
"#endif\n"
"\n"
"/* Code executed at the end of each rule. */\n"
"#ifndef YY_BREAK\n"
"#define YY_BREAK break;\n"
"#endif\n"
"\n"
"#define YY_RULE_SETUP \134\n"
"\011YY_USER_ACTION\n"
"\n"
"/** The main scanner function which does all the work.\n"
" */\n"
"YY_DECL\n"
"{\n"
"\011register yy_state_type yy_current_state;\n"
"\011register char *yy_cp, *yy_bp;\n"
"\011register int yy_act;\n"
"    \n"
"\011if ( !(yy_init) )\n"
"\011\011{\n"
"\011\011(yy_init) = 1;\n"
"\n"
"#ifdef YY_USER_INIT\n"
"\011\011YY_USER_INIT;\n"
"#endif\n"
"\n"
"\011\011if ( ! (yy_start) )\n"
"\011\011\011(yy_start) = 1;\011/* first start state */\n"
"\n"
"\011\011if ( ! cfgl_in )\n"
"\011\011\011cfgl_in = stdin;\n"
"\n"
"\011\011if ( ! cfgl_out )\n"
"\011\011\011cfgl_out = stdout;\n"
"\n"
"\011\011if ( ! YY_CURRENT_BUFFER ) {\n"
"\011\011\011cfgl_ensure_buffer_stack ();\n"
"\011\011\011YY_CURRENT_BUFFER_LVALUE =\n"
"\011\011\011\011cfgl__create_buffer(cfgl_in,YY_BUF_SIZE );\n"
"\011\011}\n"
"\n"
"\011\011cfgl__load_buffer_state( );\n"
"\011\011}\n"
"\n"
"\011while ( 1 )\011\011/* loops until end-of-file is reached */\n"
"\011\011{\n"
"\011\011yy_cp = (yy_c_buf_p);\n"
"\n"
"\011\011/* Support of cfgl_text. */\n"
"\011\011*yy_cp = (yy_hold_char);\n"
"\n"
"\011\011/* yy_bp points to the position in yy_ch_buf of the start of\n"
"\011\011 * the current run.\n"
"\011\011 */\n"
"\011\011yy_bp = yy_cp;\n"
"\n"
"\011\011yy_current_state = (yy_start);\n"
"yy_match:\n"
"\011\011do\n"
"\011\011\011{\n"
"\011\011\011register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];\n"
"\011\011\011if ( yy_accept[yy_current_state] )\n"
"\011\011\011\011{\n"
"\011\011\011\011(yy_last_accepting_state) = yy_current_state;\n"
"\011\011\011\011(yy_last_accepting_cpos) = yy_cp;\n"
"\011\011\011\011}\n"
"\011\011\011while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )\n"
"\011\011\011\011{\n"
"\011\011\011\011yy_current_state = (int) yy_def[yy_current_state];\n"
"\011\011\011\011if ( yy_current_state >= 50 )\n"
"\011\011\011\011\011yy_c = yy_meta[(unsigned int) yy_c];\n"
"\011\011\011\011}\n"
"\011\011\011yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];\n"
"\011\011\011++yy_cp;\n"
"\011\011\011}\n"
"\011\011while ( yy_base[yy_current_state] != 96 );\n"
"\n"
"yy_find_action:\n"
"\011\011yy_act = yy_accept[yy_current_state];\n"
"\011\011if ( yy_act == 0 )\n"
"\011\011\011{ /* have to back up */\n"
"\011\011\011yy_cp = (yy_last_accepting_cpos);\n"
"\011\011\011yy_current_state = (yy_last_accepting_state);\n"
"\011\011\011yy_act = yy_accept[yy_current_state];\n"
"\011\011\011}\n"
"\n"
"\011\011YY_DO_BEFORE_ACTION;\n"
"\n"
"\011\011if ( yy_act != YY_END_OF_BUFFER && yy_rule_can_match_eol[yy_act] )\n"
"\011\011\011{\n"
"\011\011\011int yyl;\n"
"\011\011\011for ( yyl = 0; yyl < cfgl_leng; ++yyl )\n"
"\011\011\011\011if ( cfgl_text[yyl] == \047\134n\047 )\n"
"\011\011\011\011\011   \n"
"    cfgl_lineno++;\n"
";\n"
"\011\011\011}\n"
"\n"
"do_action:\011/* This label is used only to access EOF actions. */\n"
"\n"
"\011\011switch ( yy_act )\n"
"\011{ /* beginning of action switch */\n"
"\011\011\011case 0: /* must back up */\n"
"\011\011\011/* undo the effects of YY_DO_BEFORE_ACTION */\n"
"\011\011\011*yy_cp = (yy_hold_char);\n"
"\011\011\011yy_cp = (yy_last_accepting_cpos);\n"
"\011\011\011yy_current_state = (yy_last_accepting_state);\n"
"\011\011\011goto yy_find_action;\n"
"\n"
"case 1:\n"
"/* rule 1 can match eol */\n"
"YY_RULE_SETUP\n"
"{ }\n"
"\011YY_BREAK\n"
"case 2:\n"
"YY_RULE_SETUP\n"
"{ BEGIN(dquote); sreset(); }\n"
"\011YY_BREAK\n"
"case 3:\n"
"YY_RULE_SETUP\n"
"{ BEGIN(squote); sreset(); }\n"
"\011YY_BREAK\n"
"case 4:\n"
"YY_RULE_SETUP\n"
"{ /* commentos */ }\n"
"\011YY_BREAK\n"
"case 5:\n"
"YY_RULE_SETUP\n"
"{ token= \047{\047; return 0; }\n"
"\011YY_BREAK\n"
"case 6:\n"
"YY_RULE_SETUP\n"
"{ token= \047}\047; return 0; }\n"
"\011YY_BREAK\n"
"case 7:\n"
"YY_RULE_SETUP\n"
"{ token= \047A\047; return 0; }\n"
"\011YY_BREAK\n"
"case 8:\n"
"YY_RULE_SETUP\n"
"{ fvalue= strtod(cfgl_text,0);\n"
"                                   token= \047F\047; return 0; }\n"
"\011YY_BREAK\n"
"case 9:\n"
"YY_RULE_SETUP\n"
"{ ivalue= strtol(cfgl_text,0,10); token= \047I\047; return 0;}\n"
"\011YY_BREAK\n"
"case 10:\n"
"YY_RULE_SETUP\n"
"{ ivalue= strtol(cfgl_text,0,0); token= \047I\047; return 0; }\n"
"\011YY_BREAK\n"
"case 11:\n"
"YY_RULE_SETUP\n"
"{ BEGIN(0); sbuf[slen]= 0; token= \047S\047; return 0; }\n"
"\011YY_BREAK\n"
"case 12:\n"
"YY_RULE_SETUP\n"
"{ BEGIN(0); sbuf[slen]= 0; token= \047S\047; return 0;}\n"
"\011YY_BREAK\n"
"case 13:\n"
"YY_RULE_SETUP\n"
"{ sput(\047\134a\047); }\n"
"\011YY_BREAK\n"
"case 14:\n"
"YY_RULE_SETUP\n"
"{ sput(\047\134b\047); }\n"
"\011YY_BREAK\n"
"case 15:\n"
"YY_RULE_SETUP\n"
"{ sput(\047\134f\047); }\n"
"\011YY_BREAK\n"
"case 16:\n"
"YY_RULE_SETUP\n"
"{ sput(\047\134n\047); }\n"
"\011YY_BREAK\n"
"case 17:\n"
"YY_RULE_SETUP\n"
"{ sput(\047\134r\047); }\n"
"\011YY_BREAK\n"
"case 18:\n"
"YY_RULE_SETUP\n"
"{ sput(\047\134t\047); }\n"
"\011YY_BREAK\n"
"case 19:\n"
"YY_RULE_SETUP\n"
"{ sput(\047\134v\047); }\n"
"\011YY_BREAK\n"
"case 20:\n"
"YY_RULE_SETUP\n"
"{\n"
"           char buf[7];\n"
"           sprintf(buf, \0420%s\042, cfgl_text+1);\n"
"           sput( strtol(buf,0,0)); };\n"
"\011YY_BREAK\n"
"case 21:\n"
"/* rule 21 can match eol */\n"
"YY_RULE_SETUP\n"
"{ sput(cfgl_text[1]); }\n"
"\011YY_BREAK\n"
"case 22:\n"
"YY_RULE_SETUP\n"
"{ sput(cfgl_text[0]); }\n"
"\011YY_BREAK\n"
"case 23:\n"
"YY_RULE_SETUP\n"
"{ cfgl_error(\042unhandled char (%d)\042, cfgl_text[0]); }\n"
"\011YY_BREAK\n"
"case YY_STATE_EOF(INITIAL):\n"
"case YY_STATE_EOF(dquote):\n"
"case YY_STATE_EOF(squote):\n"
"{ token= \047E\047; return 0; }\n"
"\011YY_BREAK\n"
"case 24:\n"
"YY_RULE_SETUP\n"
"ECHO;\n"
"\011YY_BREAK\n"
"\n"
"\011case YY_END_OF_BUFFER:\n"
"\011\011{\n"
"\011\011/* Amount of text matched not including the EOB char. */\n"
"\011\011int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;\n"
"\n"
"\011\011/* Undo the effects of YY_DO_BEFORE_ACTION. */\n"
"\011\011*yy_cp = (yy_hold_char);\n"
"\011\011YY_RESTORE_YY_MORE_OFFSET\n"
"\n"
"\011\011if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )\n"
"\011\011\011{\n"
"\011\011\011/* We\047re scanning a new file or input source.  It\047s\n"
"\011\011\011 * possible that this happened because the user\n"
"\011\011\011 * just pointed cfgl_in at a new source and called\n"
"\011\011\011 * cfgl_lex().  If so, then we have to assure\n"
"\011\011\011 * consistency between YY_CURRENT_BUFFER and our\n"
"\011\011\011 * globals.  Here is the right place to do so, because\n"
"\011\011\011 * this is the first action (other than possibly a\n"
"\011\011\011 * back-up) that will match for the new input source.\n"
"\011\011\011 */\n"
"\011\011\011(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;\n"
"\011\011\011YY_CURRENT_BUFFER_LVALUE->yy_input_file = cfgl_in;\n"
"\011\011\011YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;\n"
"\011\011\011}\n"
"\n"
"\011\011/* Note that here we test for yy_c_buf_p \042<=\042 to the position\n"
"\011\011 * of the first EOB in the buffer, since yy_c_buf_p will\n"
"\011\011 * already have been incremented past the NUL character\n"
"\011\011 * (since all states make transitions on EOB to the\n"
"\011\011 * end-of-buffer state).  Contrast this with the test\n"
"\011\011 * in input().\n"
"\011\011 */\n"
"\011\011if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )\n"
"\011\011\011{ /* This was really a NUL. */\n"
"\011\011\011yy_state_type yy_next_state;\n"
"\n"
"\011\011\011(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;\n"
"\n"
"\011\011\011yy_current_state = yy_get_previous_state(  );\n"
"\n"
"\011\011\011/* Okay, we\047re now positioned to make the NUL\n"
"\011\011\011 * transition.  We couldn\047t have\n"
"\011\011\011 * yy_get_previous_state() go ahead and do it\n"
"\011\011\011 * for us because it doesn\047t know how to deal\n"
"\011\011\011 * with the possibility of jamming (and we don\047t\n"
"\011\011\011 * want to build jamming into it because then it\n"
"\011\011\011 * will run more slowly).\n"
"\011\011\011 */\n"
"\n"
"\011\011\011yy_next_state = yy_try_NUL_trans( yy_current_state );\n"
"\n"
"\011\011\011yy_bp = (yytext_ptr) + YY_MORE_ADJ;\n"
"\n"
"\011\011\011if ( yy_next_state )\n"
"\011\011\011\011{\n"
"\011\011\011\011/* Consume the NUL. */\n"
"\011\011\011\011yy_cp = ++(yy_c_buf_p);\n"
"\011\011\011\011yy_current_state = yy_next_state;\n"
"\011\011\011\011goto yy_match;\n"
"\011\011\011\011}\n"
"\n"
"\011\011\011else\n"
"\011\011\011\011{\n"
"\011\011\011\011yy_cp = (yy_c_buf_p);\n"
"\011\011\011\011goto yy_find_action;\n"
"\011\011\011\011}\n"
"\011\011\011}\n"
"\n"
"\011\011else switch ( yy_get_next_buffer(  ) )\n"
"\011\011\011{\n"
"\011\011\011case EOB_ACT_END_OF_FILE:\n"
"\011\011\011\011{\n"
"\011\011\011\011(yy_did_buffer_switch_on_eof) = 0;\n"
"\n"
"\011\011\011\011if ( cfgl_wrap( ) )\n"
"\011\011\011\011\011{\n"
"\011\011\011\011\011/* Note: because we\047ve taken care in\n"
"\011\011\011\011\011 * yy_get_next_buffer() to have set up\n"
"\011\011\011\011\011 * cfgl_text, we can now set up\n"
"\011\011\011\011\011 * yy_c_buf_p so that if some total\n"
"\011\011\011\011\011 * hoser (like flex itself) wants to\n"
"\011\011\011\011\011 * call the scanner after we return the\n"
"\011\011\011\011\011 * YY_NULL, it\047ll still work - another\n"
"\011\011\011\011\011 * YY_NULL will get returned.\n"
"\011\011\011\011\011 */\n"
"\011\011\011\011\011(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;\n"
"\n"
"\011\011\011\011\011yy_act = YY_STATE_EOF(YY_START);\n"
"\011\011\011\011\011goto do_action;\n"
"\011\011\011\011\011}\n"
"\n"
"\011\011\011\011else\n"
"\011\011\011\011\011{\n"
"\011\011\011\011\011if ( ! (yy_did_buffer_switch_on_eof) )\n"
"\011\011\011\011\011\011YY_NEW_FILE;\n"
"\011\011\011\011\011}\n"
"\011\011\011\011break;\n"
"\011\011\011\011}\n"
"\n"
"\011\011\011case EOB_ACT_CONTINUE_SCAN:\n"
"\011\011\011\011(yy_c_buf_p) =\n"
"\011\011\011\011\011(yytext_ptr) + yy_amount_of_matched_text;\n"
"\n"
"\011\011\011\011yy_current_state = yy_get_previous_state(  );\n"
"\n"
"\011\011\011\011yy_cp = (yy_c_buf_p);\n"
"\011\011\011\011yy_bp = (yytext_ptr) + YY_MORE_ADJ;\n"
"\011\011\011\011goto yy_match;\n"
"\n"
"\011\011\011case EOB_ACT_LAST_MATCH:\n"
"\011\011\011\011(yy_c_buf_p) =\n"
"\011\011\011\011&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];\n"
"\n"
"\011\011\011\011yy_current_state = yy_get_previous_state(  );\n"
"\n"
"\011\011\011\011yy_cp = (yy_c_buf_p);\n"
"\011\011\011\011yy_bp = (yytext_ptr) + YY_MORE_ADJ;\n"
"\011\011\011\011goto yy_find_action;\n"
"\011\011\011}\n"
"\011\011break;\n"
"\011\011}\n"
"\n"
"\011default:\n"
"\011\011YY_FATAL_ERROR(\n"
"\011\011\011\042fatal flex scanner internal error--no action found\042 );\n"
"\011} /* end of action switch */\n"
"\011\011} /* end of scanning one token */\n"
"} /* end of cfgl_lex */\n"
"\n"
"/* yy_get_next_buffer - try to read in a new buffer\n"
" *\n"
" * Returns a code representing an action:\n"
" *\011EOB_ACT_LAST_MATCH -\n"
" *\011EOB_ACT_CONTINUE_SCAN - continue scanning from current position\n"
" *\011EOB_ACT_END_OF_FILE - end of file\n"
" */\n"
"static int yy_get_next_buffer (void)\n"
"{\n"
"    \011register char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;\n"
"\011register char *source = (yytext_ptr);\n"
"\011register int number_to_move, i;\n"
"\011int ret_val;\n"
"\n"
"\011if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )\n"
"\011\011YY_FATAL_ERROR(\n"
"\011\011\042fatal flex scanner internal error--end of buffer missed\042 );\n"
"\n"
"\011if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )\n"
"\011\011{ /* Don\047t try to fill the buffer, so this is an EOF. */\n"
"\011\011if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )\n"
"\011\011\011{\n"
"\011\011\011/* We matched a single character, the EOB, so\n"
"\011\011\011 * treat this as a final EOF.\n"
"\011\011\011 */\n"
"\011\011\011return EOB_ACT_END_OF_FILE;\n"
"\011\011\011}\n"
"\n"
"\011\011else\n"
"\011\011\011{\n"
"\011\011\011/* We matched some text prior to the EOB, first\n"
"\011\011\011 * process it.\n"
"\011\011\011 */\n"
"\011\011\011return EOB_ACT_LAST_MATCH;\n"
"\011\011\011}\n"
"\011\011}\n"
"\n"
"\011/* Try to read more data. */\n"
"\n"
"\011/* First move last chars to start of buffer. */\n"
"\011number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr)) - 1;\n"
"\n"
"\011for ( i = 0; i < number_to_move; ++i )\n"
"\011\011*(dest++) = *(source++);\n"
"\n"
"\011if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )\n"
"\011\011/* don\047t do the read, it\047s not guaranteed to return an EOF,\n"
"\011\011 * just force an EOF\n"
"\011\011 */\n"
"\011\011YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;\n"
"\n"
"\011else\n"
"\011\011{\n"
"\011\011\011yy_size_t num_to_read =\n"
"\011\011\011YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;\n"
"\n"
"\011\011while ( num_to_read <= 0 )\n"
"\011\011\011{ /* Not enough room in the buffer - grow it. */\n"
"\n"
"\011\011\011/* just a shorter name for the current buffer */\n"
"\011\011\011YY_BUFFER_STATE b = YY_CURRENT_BUFFER_LVALUE;\n"
"\n"
"\011\011\011int yy_c_buf_p_offset =\n"
"\011\011\011\011(int) ((yy_c_buf_p) - b->yy_ch_buf);\n"
"\n"
"\011\011\011if ( b->yy_is_our_buffer )\n"
"\011\011\011\011{\n"
"\011\011\011\011yy_size_t new_size = b->yy_buf_size * 2;\n"
"\n"
"\011\011\011\011if ( new_size <= 0 )\n"
"\011\011\011\011\011b->yy_buf_size += b->yy_buf_size / 8;\n"
"\011\011\011\011else\n"
"\011\011\011\011\011b->yy_buf_size *= 2;\n"
"\n"
"\011\011\011\011b->yy_ch_buf = (char *)\n"
"\011\011\011\011\011/* Include room in for 2 EOB chars. */\n"
"\011\011\011\011\011cfgl_realloc((void *) b->yy_ch_buf,b->yy_buf_size + 2  );\n"
"\011\011\011\011}\n"
"\011\011\011else\n"
"\011\011\011\011/* Can\047t grow it, we don\047t own it. */\n"
"\011\011\011\011b->yy_ch_buf = 0;\n"
"\n"
"\011\011\011if ( ! b->yy_ch_buf )\n"
"\011\011\011\011YY_FATAL_ERROR(\n"
"\011\011\011\011\042fatal error - scanner input buffer overflow\042 );\n"
"\n"
"\011\011\011(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];\n"
"\n"
"\011\011\011num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -\n"
"\011\011\011\011\011\011number_to_move - 1;\n"
"\n"
"\011\011\011}\n"
"\n"
"\011\011if ( num_to_read > YY_READ_BUF_SIZE )\n"
"\011\011\011num_to_read = YY_READ_BUF_SIZE;\n"
"\n"
"\011\011/* Read in more data. */\n"
"\011\011YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),\n"
"\011\011\011(yy_n_chars), num_to_read );\n"
"\n"
"\011\011YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);\n"
"\011\011}\n"
"\n"
"\011if ( (yy_n_chars) == 0 )\n"
"\011\011{\n"
"\011\011if ( number_to_move == YY_MORE_ADJ )\n"
"\011\011\011{\n"
"\011\011\011ret_val = EOB_ACT_END_OF_FILE;\n"
"\011\011\011cfgl_restart(cfgl_in  );\n"
"\011\011\011}\n"
"\n"
"\011\011else\n"
"\011\011\011{\n"
"\011\011\011ret_val = EOB_ACT_LAST_MATCH;\n"
"\011\011\011YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =\n"
"\011\011\011\011YY_BUFFER_EOF_PENDING;\n"
"\011\011\011}\n"
"\011\011}\n"
"\n"
"\011else\n"
"\011\011ret_val = EOB_ACT_CONTINUE_SCAN;\n"
"\n"
"\011if ((yy_size_t) ((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {\n"
"\011\011/* Extend the array by 50%, plus the number we really need. */\n"
"\011\011yy_size_t new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);\n"
"\011\011YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) cfgl_realloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,new_size  );\n"
"\011\011if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )\n"
"\011\011\011YY_FATAL_ERROR( \042out of dynamic memory in yy_get_next_buffer()\042 );\n"
"\011}\n"
"\n"
"\011(yy_n_chars) += number_to_move;\n"
"\011YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;\n"
"\011YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;\n"
"\n"
"\011(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];\n"
"\n"
"\011return ret_val;\n"
"}\n"
"\n"
"/* yy_get_previous_state - get the state just before the EOB char was reached */\n"
"\n"
"    static yy_state_type yy_get_previous_state (void)\n"
"{\n"
"\011register yy_state_type yy_current_state;\n"
"\011register char *yy_cp;\n"
"    \n"
"\011yy_current_state = (yy_start);\n"
"\n"
"\011for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )\n"
"\011\011{\n"
"\011\011register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 3);\n"
"\011\011if ( yy_accept[yy_current_state] )\n"
"\011\011\011{\n"
"\011\011\011(yy_last_accepting_state) = yy_current_state;\n"
"\011\011\011(yy_last_accepting_cpos) = yy_cp;\n"
"\011\011\011}\n"
"\011\011while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )\n"
"\011\011\011{\n"
"\011\011\011yy_current_state = (int) yy_def[yy_current_state];\n"
"\011\011\011if ( yy_current_state >= 50 )\n"
"\011\011\011\011yy_c = yy_meta[(unsigned int) yy_c];\n"
"\011\011\011}\n"
"\011\011yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];\n"
"\011\011}\n"
"\n"
"\011return yy_current_state;\n"
"}\n"
"\n"
"/* yy_try_NUL_trans - try to make a transition on the NUL character\n"
" *\n"
" * synopsis\n"
" *\011next_state = yy_try_NUL_trans( current_state );\n"
" */\n"
"    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )\n"
"{\n"
"\011register int yy_is_jam;\n"
"    \011register char *yy_cp = (yy_c_buf_p);\n"
"\n"
"\011register YY_CHAR yy_c = 3;\n"
"\011if ( yy_accept[yy_current_state] )\n"
"\011\011{\n"
"\011\011(yy_last_accepting_state) = yy_current_state;\n"
"\011\011(yy_last_accepting_cpos) = yy_cp;\n"
"\011\011}\n"
"\011while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )\n"
"\011\011{\n"
"\011\011yy_current_state = (int) yy_def[yy_current_state];\n"
"\011\011if ( yy_current_state >= 50 )\n"
"\011\011\011yy_c = yy_meta[(unsigned int) yy_c];\n"
"\011\011}\n"
"\011yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];\n"
"\011yy_is_jam = (yy_current_state == 49);\n"
"\n"
"\011\011return yy_is_jam ? 0 : yy_current_state;\n"
"}\n"
"\n"
"#ifndef YY_NO_INPUT\n"
"#ifdef __cplusplus\n"
"    static int yyinput (void)\n"
"#else\n"
"    static int input  (void)\n"
"#endif\n"
"\n"
"{\n"
"\011int c;\n"
"    \n"
"\011*(yy_c_buf_p) = (yy_hold_char);\n"
"\n"
"\011if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )\n"
"\011\011{\n"
"\011\011/* yy_c_buf_p now points to the character we want to return.\n"
"\011\011 * If this occurs *before* the EOB characters, then it\047s a\n"
"\011\011 * valid NUL; if not, then we\047ve hit the end of the buffer.\n"
"\011\011 */\n"
"\011\011if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )\n"
"\011\011\011/* This was really a NUL. */\n"
"\011\011\011*(yy_c_buf_p) = \047\1340\047;\n"
"\n"
"\011\011else\n"
"\011\011\011{ /* need more input */\n"
"\011\011\011yy_size_t offset = (yy_c_buf_p) - (yytext_ptr);\n"
"\011\011\011++(yy_c_buf_p);\n"
"\n"
"\011\011\011switch ( yy_get_next_buffer(  ) )\n"
"\011\011\011\011{\n"
"\011\011\011\011case EOB_ACT_LAST_MATCH:\n"
"\011\011\011\011\011/* This happens because yy_g_n_b()\n"
"\011\011\011\011\011 * sees that we\047ve accumulated a\n"
"\011\011\011\011\011 * token and flags that we need to\n"
"\011\011\011\011\011 * try matching the token before\n"
"\011\011\011\011\011 * proceeding.  But for input(),\n"
"\011\011\011\011\011 * there\047s no matching to consider.\n"
"\011\011\011\011\011 * So convert the EOB_ACT_LAST_MATCH\n"
"\011\011\011\011\011 * to EOB_ACT_END_OF_FILE.\n"
"\011\011\011\011\011 */\n"
"\n"
"\011\011\011\011\011/* Reset buffer status. */\n"
"\011\011\011\011\011cfgl_restart(cfgl_in );\n"
"\n"
"\011\011\011\011\011/*FALLTHROUGH*/\n"
"\n"
"\011\011\011\011case EOB_ACT_END_OF_FILE:\n"
"\011\011\011\011\011{\n"
"\011\011\011\011\011if ( cfgl_wrap( ) )\n"
"\011\011\011\011\011\011return EOF;\n"
"\n"
"\011\011\011\011\011if ( ! (yy_did_buffer_switch_on_eof) )\n"
"\011\011\011\011\011\011YY_NEW_FILE;\n"
"#ifdef __cplusplus\n"
"\011\011\011\011\011return yyinput();\n"
"#else\n"
"\011\011\011\011\011return input();\n"
"#endif\n"
"\011\011\011\011\011}\n"
"\n"
"\011\011\011\011case EOB_ACT_CONTINUE_SCAN:\n"
"\011\011\011\011\011(yy_c_buf_p) = (yytext_ptr) + offset;\n"
"\011\011\011\011\011break;\n"
"\011\011\011\011}\n"
"\011\011\011}\n"
"\011\011}\n"
"\n"
"\011c = *(unsigned char *) (yy_c_buf_p);\011/* cast for 8-bit char\047s */\n"
"\011*(yy_c_buf_p) = \047\1340\047;\011/* preserve cfgl_text */\n"
"\011(yy_hold_char) = *++(yy_c_buf_p);\n"
"\n"
"\011if ( c == \047\134n\047 )\n"
"\011\011   \n"
"    cfgl_lineno++;\n"
";\n"
"\n"
"\011return c;\n"
"}\n"
"#endif\011/* ifndef YY_NO_INPUT */\n"
"\n"
"/** Immediately switch to a different input stream.\n"
" * @param input_file A readable stream.\n"
" * \n"
" * @note This function does not reset the start condition to @c INITIAL .\n"
" */\n"
"    void cfgl_restart  (FILE * input_file )\n"
"{\n"
"    \n"
"\011if ( ! YY_CURRENT_BUFFER ){\n"
"        cfgl_ensure_buffer_stack ();\n"
"\011\011YY_CURRENT_BUFFER_LVALUE =\n"
"            cfgl__create_buffer(cfgl_in,YY_BUF_SIZE );\n"
"\011}\n"
"\n"
"\011cfgl__init_buffer(YY_CURRENT_BUFFER,input_file );\n"
"\011cfgl__load_buffer_state( );\n"
"}\n"
"\n"
"/** Switch to a different input buffer.\n"
" * @param new_buffer The new input buffer.\n"
" * \n"
" */\n"
"    void cfgl__switch_to_buffer  (YY_BUFFER_STATE  new_buffer )\n"
"{\n"
"    \n"
"\011/* TODO. We should be able to replace this entire function body\n"
"\011 * with\n"
"\011 *\011\011cfgl_pop_buffer_state();\n"
"\011 *\011\011cfgl_push_buffer_state(new_buffer);\n"
"     */\n"
"\011cfgl_ensure_buffer_stack ();\n"
"\011if ( YY_CURRENT_BUFFER == new_buffer )\n"
"\011\011return;\n"
"\n"
"\011if ( YY_CURRENT_BUFFER )\n"
"\011\011{\n"
"\011\011/* Flush out information for old buffer. */\n"
"\011\011*(yy_c_buf_p) = (yy_hold_char);\n"
"\011\011YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);\n"
"\011\011YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);\n"
"\011\011}\n"
"\n"
"\011YY_CURRENT_BUFFER_LVALUE = new_buffer;\n"
"\011cfgl__load_buffer_state( );\n"
"\n"
"\011/* We don\047t actually know whether we did this switch during\n"
"\011 * EOF (cfgl_wrap()) processing, but the only time this flag\n"
"\011 * is looked at is after cfgl_wrap() is called, so it\047s safe\n"
"\011 * to go ahead and always set it.\n"
"\011 */\n"
"\011(yy_did_buffer_switch_on_eof) = 1;\n"
"}\n"
"\n"
"static void cfgl__load_buffer_state  (void)\n"
"{\n"
"    \011(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;\n"
"\011(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;\n"
"\011cfgl_in = YY_CURRENT_BUFFER_LVALUE->yy_input_file;\n"
"\011(yy_hold_char) = *(yy_c_buf_p);\n"
"}\n"
"\n"
"/** Allocate and initialize an input buffer state.\n"
" * @param file A readable stream.\n"
" * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.\n"
" * \n"
" * @return the allocated buffer state.\n"
" */\n"
"    YY_BUFFER_STATE cfgl__create_buffer  (FILE * file, int  size )\n"
"{\n"
"\011YY_BUFFER_STATE b;\n"
"    \n"
"\011b = (YY_BUFFER_STATE) cfgl_alloc(sizeof( struct yy_buffer_state )  );\n"
"\011if ( ! b )\n"
"\011\011YY_FATAL_ERROR( \042out of dynamic memory in cfgl__create_buffer()\042 );\n"
"\n"
"\011b->yy_buf_size = size;\n"
"\n"
"\011/* yy_ch_buf has to be 2 characters longer than the size given because\n"
"\011 * we need to put in 2 end-of-buffer characters.\n"
"\011 */\n"
"\011b->yy_ch_buf = (char *) cfgl_alloc(b->yy_buf_size + 2  );\n"
"\011if ( ! b->yy_ch_buf )\n"
"\011\011YY_FATAL_ERROR( \042out of dynamic memory in cfgl__create_buffer()\042 );\n"
"\n"
"\011b->yy_is_our_buffer = 1;\n"
"\n"
"\011cfgl__init_buffer(b,file );\n"
"\n"
"\011return b;\n"
"}\n"
"\n"
"/** Destroy the buffer.\n"
" * @param b a buffer created with cfgl__create_buffer()\n"
" * \n"
" */\n"
"    void cfgl__delete_buffer (YY_BUFFER_STATE  b )\n"
"{\n"
"    \n"
"\011if ( ! b )\n"
"\011\011return;\n"
"\n"
"\011if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */\n"
"\011\011YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;\n"
"\n"
"\011if ( b->yy_is_our_buffer )\n"
"\011\011cfgl_free((void *) b->yy_ch_buf  );\n"
"\n"
"\011cfgl_free((void *) b  );\n"
"}\n"
"\n"
"/* Initializes or reinitializes a buffer.\n"
" * This function is sometimes called more than once on the same buffer,\n"
" * such as during a cfgl_restart() or at EOF.\n"
" */\n"
"    static void cfgl__init_buffer  (YY_BUFFER_STATE  b, FILE * file )\n"
"\n"
"{\n"
"\011int oerrno = errno;\n"
"    \n"
"\011cfgl__flush_buffer(b );\n"
"\n"
"\011b->yy_input_file = file;\n"
"\011b->yy_fill_buffer = 1;\n"
"\n"
"    /* If b is the current buffer, then cfgl__init_buffer was _probably_\n"
"     * called from cfgl_restart() or through yy_get_next_buffer.\n"
"     * In that case, we don\047t want to reset the lineno or column.\n"
"     */\n"
"    if (b != YY_CURRENT_BUFFER){\n"
"        b->yy_bs_lineno = 1;\n"
"        b->yy_bs_column = 0;\n"
"    }\n"
"\n"
"        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;\n"
"    \n"
"\011errno = oerrno;\n"
"}\n"
"\n"
"/** Discard all buffered characters. On the next scan, YY_INPUT will be called.\n"
" * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.\n"
" * \n"
" */\n"
"    void cfgl__flush_buffer (YY_BUFFER_STATE  b )\n"
"{\n"
"    \011if ( ! b )\n"
"\011\011return;\n"
"\n"
"\011b->yy_n_chars = 0;\n"
"\n"
"\011/* We always need two end-of-buffer characters.  The first causes\n"
"\011 * a transition to the end-of-buffer state.  The second causes\n"
"\011 * a jam in that state.\n"
"\011 */\n"
"\011b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;\n"
"\011b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;\n"
"\n"
"\011b->yy_buf_pos = &b->yy_ch_buf[0];\n"
"\n"
"\011b->yy_at_bol = 1;\n"
"\011b->yy_buffer_status = YY_BUFFER_NEW;\n"
"\n"
"\011if ( b == YY_CURRENT_BUFFER )\n"
"\011\011cfgl__load_buffer_state( );\n"
"}\n"
"\n"
"/** Pushes the new state onto the stack. The new state becomes\n"
" *  the current state. This function will allocate the stack\n"
" *  if necessary.\n"
" *  @param new_buffer The new state.\n"
" *  \n"
" */\n"
"void cfgl_push_buffer_state (YY_BUFFER_STATE new_buffer )\n"
"{\n"
"    \011if (new_buffer == NULL)\n"
"\011\011return;\n"
"\n"
"\011cfgl_ensure_buffer_stack();\n"
"\n"
"\011/* This block is copied from cfgl__switch_to_buffer. */\n"
"\011if ( YY_CURRENT_BUFFER )\n"
"\011\011{\n"
"\011\011/* Flush out information for old buffer. */\n"
"\011\011*(yy_c_buf_p) = (yy_hold_char);\n"
"\011\011YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);\n"
"\011\011YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);\n"
"\011\011}\n"
"\n"
"\011/* Only push if top exists. Otherwise, replace top. */\n"
"\011if (YY_CURRENT_BUFFER)\n"
"\011\011(yy_buffer_stack_top)++;\n"
"\011YY_CURRENT_BUFFER_LVALUE = new_buffer;\n"
"\n"
"\011/* copied from cfgl__switch_to_buffer. */\n"
"\011cfgl__load_buffer_state( );\n"
"\011(yy_did_buffer_switch_on_eof) = 1;\n"
"}\n"
"\n"
"/** Removes and deletes the top of the stack, if present.\n"
" *  The next element becomes the new top.\n"
" *  \n"
" */\n"
"void cfgl_pop_buffer_state (void)\n"
"{\n"
"    \011if (!YY_CURRENT_BUFFER)\n"
"\011\011return;\n"
"\n"
"\011cfgl__delete_buffer(YY_CURRENT_BUFFER );\n"
"\011YY_CURRENT_BUFFER_LVALUE = NULL;\n"
"\011if ((yy_buffer_stack_top) > 0)\n"
"\011\011--(yy_buffer_stack_top);\n"
"\n"
"\011if (YY_CURRENT_BUFFER) {\n"
"\011\011cfgl__load_buffer_state( );\n"
"\011\011(yy_did_buffer_switch_on_eof) = 1;\n"
"\011}\n"
"}\n"
"\n"
"/* Allocates the stack if it does not exist.\n"
" *  Guarantees space for at least one push.\n"
" */\n"
"static void cfgl_ensure_buffer_stack (void)\n"
"{\n"
"\011yy_size_t num_to_alloc;\n"
"    \n"
"\011if (!(yy_buffer_stack)) {\n"
"\n"
"\011\011/* First allocation is just for 2 elements, since we don\047t know if this\n"
"\011\011 * scanner will even need a stack. We use 2 instead of 1 to avoid an\n"
"\011\011 * immediate realloc on the next call.\n"
"         */\n"
"\011\011num_to_alloc = 1;\n"
"\011\011(yy_buffer_stack) = (struct yy_buffer_state**)cfgl_alloc\n"
"\011\011\011\011\011\011\011\011(num_to_alloc * sizeof(struct yy_buffer_state*)\n"
"\011\011\011\011\011\011\011\011);\n"
"\011\011if ( ! (yy_buffer_stack) )\n"
"\011\011\011YY_FATAL_ERROR( \042out of dynamic memory in cfgl_ensure_buffer_stack()\042 );\n"
"\011\011\011\011\011\011\011\011  \n"
"\011\011memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));\n"
"\011\011\011\011\n"
"\011\011(yy_buffer_stack_max) = num_to_alloc;\n"
"\011\011(yy_buffer_stack_top) = 0;\n"
"\011\011return;\n"
"\011}\n"
"\n"
"\011if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){\n"
"\n"
"\011\011/* Increase the buffer to prepare for a possible push. */\n"
"\011\011int grow_size = 8 /* arbitrary grow size */;\n"
"\n"
"\011\011num_to_alloc = (yy_buffer_stack_max) + grow_size;\n"
"\011\011(yy_buffer_stack) = (struct yy_buffer_state**)cfgl_realloc\n"
"\011\011\011\011\011\011\011\011((yy_buffer_stack),\n"
"\011\011\011\011\011\011\011\011num_to_alloc * sizeof(struct yy_buffer_state*)\n"
"\011\011\011\011\011\011\011\011);\n"
"\011\011if ( ! (yy_buffer_stack) )\n"
"\011\011\011YY_FATAL_ERROR( \042out of dynamic memory in cfgl_ensure_buffer_stack()\042 );\n"
"\n"
"\011\011/* zero only the new slots.*/\n"
"\011\011memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));\n"
"\011\011(yy_buffer_stack_max) = num_to_alloc;\n"
"\011}\n"
"}\n"
"\n"
"/** Setup the input buffer state to scan directly from a user-specified character buffer.\n"
" * @param base the character buffer\n"
" * @param size the size in bytes of the character buffer\n"
" * \n"
" * @return the newly allocated buffer state object. \n"
" */\n"
"YY_BUFFER_STATE cfgl__scan_buffer  (char * base, yy_size_t  size )\n"
"{\n"
"\011YY_BUFFER_STATE b;\n"
"    \n"
"\011if ( size < 2 ||\n"
"\011     base[size-2] != YY_END_OF_BUFFER_CHAR ||\n"
"\011     base[size-1] != YY_END_OF_BUFFER_CHAR )\n"
"\011\011/* They forgot to leave room for the EOB\047s. */\n"
"\011\011return 0;\n"
"\n"
"\011b = (YY_BUFFER_STATE) cfgl_alloc(sizeof( struct yy_buffer_state )  );\n"
"\011if ( ! b )\n"
"\011\011YY_FATAL_ERROR( \042out of dynamic memory in cfgl__scan_buffer()\042 );\n"
"\n"
"\011b->yy_buf_size = size - 2;\011/* \042- 2\042 to take care of EOB\047s */\n"
"\011b->yy_buf_pos = b->yy_ch_buf = base;\n"
"\011b->yy_is_our_buffer = 0;\n"
"\011b->yy_input_file = 0;\n"
"\011b->yy_n_chars = b->yy_buf_size;\n"
"\011b->yy_is_interactive = 0;\n"
"\011b->yy_at_bol = 1;\n"
"\011b->yy_fill_buffer = 0;\n"
"\011b->yy_buffer_status = YY_BUFFER_NEW;\n"
"\n"
"\011cfgl__switch_to_buffer(b  );\n"
"\n"
"\011return b;\n"
"}\n"
"\n"
"/** Setup the input buffer state to scan a string. The next call to cfgl_lex() will\n"
" * scan from a @e copy of @a str.\n"
" * @param yystr a NUL-terminated string to scan\n"
" * \n"
" * @return the newly allocated buffer state object.\n"
" * @note If you want to scan bytes that may contain NUL values, then use\n"
" *       cfgl__scan_bytes() instead.\n"
" */\n"
"YY_BUFFER_STATE cfgl__scan_string (yyconst char * yystr )\n"
"{\n"
"    \n"
"\011return cfgl__scan_bytes(yystr,strlen(yystr) );\n"
"}\n"
"\n"
"/** Setup the input buffer state to scan the given bytes. The next call to cfgl_lex() will\n"
" * scan from a @e copy of @a bytes.\n"
" * @param yybytes the byte buffer to scan\n"
" * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.\n"
" * \n"
" * @return the newly allocated buffer state object.\n"
" */\n"
"YY_BUFFER_STATE cfgl__scan_bytes  (yyconst char * yybytes, yy_size_t  _yybytes_len )\n"
"{\n"
"\011YY_BUFFER_STATE b;\n"
"\011char *buf;\n"
"\011yy_size_t n;\n"
"\011int i;\n"
"    \n"
"\011/* Get memory for full buffer, including space for trailing EOB\047s. */\n"
"\011n = _yybytes_len + 2;\n"
"\011buf = (char *) cfgl_alloc(n  );\n"
"\011if ( ! buf )\n"
"\011\011YY_FATAL_ERROR( \042out of dynamic memory in cfgl__scan_bytes()\042 );\n"
"\n"
"\011for ( i = 0; i < _yybytes_len; ++i )\n"
"\011\011buf[i] = yybytes[i];\n"
"\n"
"\011buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;\n"
"\n"
"\011b = cfgl__scan_buffer(buf,n );\n"
"\011if ( ! b )\n"
"\011\011YY_FATAL_ERROR( \042bad buffer in cfgl__scan_bytes()\042 );\n"
"\n"
"\011/* It\047s okay to grow etc. this buffer, and we should throw it\n"
"\011 * away when we\047re done.\n"
"\011 */\n"
"\011b->yy_is_our_buffer = 1;\n"
"\n"
"\011return b;\n"
"}\n"
"\n"
"#ifndef YY_EXIT_FAILURE\n"
"#define YY_EXIT_FAILURE 2\n"
"#endif\n"
"\n"
"static void yy_fatal_error (yyconst char* msg )\n"
"{\n"
"    \011(void) fprintf( stderr, \042%s\134n\042, msg );\n"
"\011exit( YY_EXIT_FAILURE );\n"
"}\n"
"\n"
"/* Redefine yyless() so it works in section 3 code. */\n"
"\n"
"#undef yyless\n"
"#define yyless(n) \134\n"
"\011do \134\n"
"\011\011{ \134\n"
"\011\011/* Undo effects of setting up cfgl_text. */ \134\n"
"        int yyless_macro_arg = (n); \134\n"
"        YY_LESS_LINENO(yyless_macro_arg);\134\n"
"\011\011cfgl_text[cfgl_leng] = (yy_hold_char); \134\n"
"\011\011(yy_c_buf_p) = cfgl_text + yyless_macro_arg; \134\n"
"\011\011(yy_hold_char) = *(yy_c_buf_p); \134\n"
"\011\011*(yy_c_buf_p) = \047\1340\047; \134\n"
"\011\011cfgl_leng = yyless_macro_arg; \134\n"
"\011\011} \134\n"
"\011while ( 0 )\n"
"\n"
"/* Accessor  methods (get/set functions) to struct members. */\n"
"\n"
"/** Get the current line number.\n"
" * \n"
" */\n"
"int cfgl_get_lineno  (void)\n"
"{\n"
"        \n"
"    return cfgl_lineno;\n"
"}\n"
"\n"
"/** Get the input stream.\n"
" * \n"
" */\n"
"FILE *cfgl_get_in  (void)\n"
"{\n"
"        return cfgl_in;\n"
"}\n"
"\n"
"/** Get the output stream.\n"
" * \n"
" */\n"
"FILE *cfgl_get_out  (void)\n"
"{\n"
"        return cfgl_out;\n"
"}\n"
"\n"
"/** Get the length of the current token.\n"
" * \n"
" */\n"
"yy_size_t cfgl_get_leng  (void)\n"
"{\n"
"        return cfgl_leng;\n"
"}\n"
"\n"
"/** Get the current token.\n"
" * \n"
" */\n"
"\n"
"char *cfgl_get_text  (void)\n"
"{\n"
"        return cfgl_text;\n"
"}\n"
"\n"
"/** Set the current line number.\n"
" * @param line_number\n"
" * \n"
" */\n"
"void cfgl_set_lineno (int  line_number )\n"
"{\n"
"    \n"
"    cfgl_lineno = line_number;\n"
"}\n"
"\n"
"/** Set the input stream. This does not discard the current\n"
" * input buffer.\n"
" * @param in_str A readable stream.\n"
" * \n"
" * @see cfgl__switch_to_buffer\n"
" */\n"
"void cfgl_set_in (FILE *  in_str )\n"
"{\n"
"        cfgl_in = in_str ;\n"
"}\n"
"\n"
"void cfgl_set_out (FILE *  out_str )\n"
"{\n"
"        cfgl_out = out_str ;\n"
"}\n"
"\n"
"int cfgl_get_debug  (void)\n"
"{\n"
"        return cfgl__flex_debug;\n"
"}\n"
"\n"
"void cfgl_set_debug (int  bdebug )\n"
"{\n"
"        cfgl__flex_debug = bdebug ;\n"
"}\n"
"\n"
"static int yy_init_globals (void)\n"
"{\n"
"        /* Initialization is the same as for the non-reentrant scanner.\n"
"     * This function is called from cfgl_lex_destroy(), so don\047t allocate here.\n"
"     */\n"
"\n"
"    /* We do not touch cfgl_lineno unless the option is enabled. */\n"
"    cfgl_lineno =  1;\n"
"    \n"
"    (yy_buffer_stack) = 0;\n"
"    (yy_buffer_stack_top) = 0;\n"
"    (yy_buffer_stack_max) = 0;\n"
"    (yy_c_buf_p) = (char *) 0;\n"
"    (yy_init) = 0;\n"
"    (yy_start) = 0;\n"
"\n"
"/* Defined in main.c */\n"
"#ifdef YY_STDINIT\n"
"    cfgl_in = stdin;\n"
"    cfgl_out = stdout;\n"
"#else\n"
"    cfgl_in = (FILE *) 0;\n"
"    cfgl_out = (FILE *) 0;\n"
"#endif\n"
"\n"
"    /* For future reference: Set errno on error, since we are called by\n"
"     * cfgl_lex_init()\n"
"     */\n"
"    return 0;\n"
"}\n"
"\n"
"/* cfgl_lex_destroy is for both reentrant and non-reentrant scanners. */\n"
"int cfgl_lex_destroy  (void)\n"
"{\n"
"    \n"
"    /* Pop the buffer stack, destroying each element. */\n"
"\011while(YY_CURRENT_BUFFER){\n"
"\011\011cfgl__delete_buffer(YY_CURRENT_BUFFER  );\n"
"\011\011YY_CURRENT_BUFFER_LVALUE = NULL;\n"
"\011\011cfgl_pop_buffer_state();\n"
"\011}\n"
"\n"
"\011/* Destroy the stack itself. */\n"
"\011cfgl_free((yy_buffer_stack) );\n"
"\011(yy_buffer_stack) = NULL;\n"
"\n"
"    /* Reset the globals. This is important in a non-reentrant scanner so the next time\n"
"     * cfgl_lex() is called, initialization will occur. */\n"
"    yy_init_globals( );\n"
"\n"
"    return 0;\n"
"}\n"
"\n"
"/*\n"
" * Internal utility routines.\n"
" */\n"
"\n"
"#ifndef yytext_ptr\n"
"static void yy_flex_strncpy (char* s1, yyconst char * s2, int n )\n"
"{\n"
"\011register int i;\n"
"\011for ( i = 0; i < n; ++i )\n"
"\011\011s1[i] = s2[i];\n"
"}\n"
"#endif\n"
"\n"
"#ifdef YY_NEED_STRLEN\n"
"static int yy_flex_strlen (yyconst char * s )\n"
"{\n"
"\011register int n;\n"
"\011for ( n = 0; s[n]; ++n )\n"
"\011\011;\n"
"\n"
"\011return n;\n"
"}\n"
"#endif\n"
"\n"
"void *cfgl_alloc (yy_size_t  size )\n"
"{\n"
"\011return (void *) malloc( size );\n"
"}\n"
"\n"
"void *cfgl_realloc  (void * ptr, yy_size_t  size )\n"
"{\n"
"\011/* The cast to (char *) in the following accommodates both\n"
"\011 * implementations that use char* generic pointers, and those\n"
"\011 * that use void* generic pointers.  It works with the latter\n"
"\011 * because both ANSI C and C++ allow castless assignment from\n"
"\011 * any pointer type to void*, and deal with argument conversions\n"
"\011 * as though doing an assignment.\n"
"\011 */\n"
"\011return (void *) realloc( (char *) ptr, size );\n"
"}\n"
"\n"
"void cfgl_free (void * ptr )\n"
"{\n"
"\011free( (char *) ptr );\011/* see cfgl_realloc() for (char *) cast */\n"
"}\n"
"\n"
"#define YYTABLES_NAME \042yytables\042\n"
"\n"
"/*** THIS IS THE FLEX END ***/\n"
"\n"
"static char* cfgl_parse_top(char *fn,void *ptr, cfgl_field_t *fields)\n"
"{\n"
"  FILE *f;\n"
"  f= fopen(fn,\042r\042);\n"
"  if (!f) {\n"
"    snprintf(cfgl_ebuf,sizeof(cfgl_ebuf)-1, \042can\047t open \047%s\047\134n\042, fn); \n"
"    return cfgl_ebuf;\n"
"  }\n"
"  cfgl_fname= fn;\n"
"  if (setjmp(cfgl_elabel)) \n"
"     return cfgl_ebuf;\n"
"  yyin= f;\n"
"  yylex();\n"
"  while(token!=\047E\047) \n"
"    cfgl_parse_field(ptr, fields);\n"
"  fclose(f);\n"
"  return 0;\n"
"}\n"
"\n"
"\n"
"static void cfgl_parse_struct(void *ptr, cfgl_field_t *fields)\n"
"{\n"
"  yylex();\n"
"  if (token==\047{\047) {\n"
"    yylex();\n"
"    while(token!=\047}\047)\n"
"      cfgl_parse_field(ptr, fields);\n"
"    yylex();\n"
"  } else cfgl_parse_field(ptr, fields);\n"
"}\n"
"\n"
"\n"
"static void cfgl_parse_field(void *ptr, cfgl_field_t *fields)\n"
"{\n"
"  int i;\n"
"  if (token!=\047A\047) \n"
"    cfgl_error(\042an identifier was expected\042);\n"
"  for(i=0;fields[i].name;i++)\n"
"   if (!strcmp(fields[i].name, yytext)) {\n"
"     cfgl_field_t *F= fields+i;\n"
"     switch(F->kind) {\n"
"     case \047I\047: cfgl_parse_intarray(ptr + F->offset,\n"
"                     ptr+ F->soffset, ptr+ F->noffset, F->arg); return;\n"
"     case \047F\047: cfgl_parse_floarray(ptr + F->offset,\n"
"                     ptr+ F->soffset, ptr+ F->noffset, F->arg); return;\n"
"     case \047S\047: cfgl_parse_strarray(ptr + F->offset,\n"
"                     ptr+ F->soffset, ptr+ F->noffset, F->arg); return;\n"
"     case \047R\047: cfgl_parse_recarray(ptr+F->offset, \n"
"                    ptr+ F->soffset, ptr+F->noffset, F->eltsize,\n"
"                    F->arg); return;\n"
"     case \047i\047: cfgl_parse_int(ptr+F->offset, ptr+F->goffset, F->arg); return;\n"
"     case \047f\047: cfgl_parse_flo(ptr+F->offset, ptr+F->goffset, F->arg); return;\n"
"     case \047s\047: cfgl_parse_str(ptr+F->offset, ptr+F->goffset, F->arg); return;\n"
"     case \047r\047: cfgl_parse_struct(ptr+F->offset, F->arg); return;\n"
"     }\n"
"   }\n"
"   cfgl_error(\042unknown field \047%s\047\042, yytext);\n"
"}\n"
"\n"
"\n"
"static void cfgl_parse_int(int *ptr, char *given, cfgl_intcst_t *cst)\n"
"{\n"
"  yylex();\n"
"  if (token==\047I\047) { *ptr= ivalue; }\n"
"  else if (token==\047F\047) { *ptr= fvalue; }\n"
"  else if (token==\047A\047) { cfgl_lookup_int(cst,ptr); }\n"
"  else cfgl_error(\042syntax error. expecting an integer\042);\n"
"  yylex();\n"
"  *given= 1;\n"
"}\n"
"\n"
"static void cfgl_lookup_int(cfgl_intcst_t *cst, int *ptr)\n"
"{\n"
"  int i;\n"
"  if (cst) for(i=0;cst[i].name;i++)\n"
"    if (!strcmp(cst[i].name, yytext)) { *ptr= cst[i].value; return ; }\n"
"  cst= cfgl_global_intcst;\n"
"  for(i=0;cst[i].name;i++)\n"
"    if (!strcmp(cst[i].name, yytext)) { *ptr= cst[i].value; return ; }\n"
"  cfgl_error(\042unknown constant \047%s\047\042, yytext);\n"
"}\n"
"\n"
"static void cfgl_lookup_flo(cfgl_flocst_t *cst, double *ptr)\n"
"{\n"
"  int i;\n"
"  if (cst) for(i=0;cst[i].name;i++)\n"
"    if (!strcmp(cst[i].name, yytext)) { *ptr= cst[i].value; return ; }\n"
"  cst= cfgl_global_flocst;\n"
"  for(i=0;cst[i].name;i++)\n"
"    if (!strcmp(cst[i].name, yytext)) { *ptr= cst[i].value; return ; }\n"
"  cfgl_error(\042unknown constant \047%s\047\042, yytext);\n"
"}\n"
"\n"
"static void cfgl_lookup_str(cfgl_strcst_t *cst, char **ptr)\n"
"{\n"
"  int i;\n"
"  if (cst) for(i=0;cst[i].name;i++)\n"
"    if (!strcmp(cst[i].name, yytext)) { *ptr= strdup(cst[i].value); return ; }\n"
"  cst= cfgl_global_strcst;\n"
"  for(i=0;cst[i].name;i++)\n"
"    if (!strcmp(cst[i].name, yytext)) { *ptr= strdup(cst[i].value); return ; }\n"
"  cfgl_error(\042unknown constant \047%s\047\042, yytext);\n"
"}\n"
"\n"
"static void cfgl_parse_intarray\n"
"   (int **ptr, int *size, int *len, cfgl_intcst_t *cst)\n"
"{\n"
"  yylex();\n"
"  if (token==\047{\047) {\n"
"    yylex();\n"
"    while(token!=\047}\047) \n"
"      cfgl_put_int(ptr, size, len, cst);\n"
"    yylex();\n"
"  } else cfgl_put_int(ptr, size, len,cst);\n"
"}\n"
"\n"
"static void cfgl_put_int\n"
"  (int **ptr, int *size, int *len, cfgl_intcst_t *cst)\n"
"{\n"
"  int *v;\n"
"  if (token==\047}\047) return ;\n"
"  v= cfgl_array_grow(ptr, size, len, sizeof(int));\n"
"  if (token==\047I\047)      { *v= ivalue; } \n"
"  else if (token==\047F\047) { *v= fvalue; }\n"
"  else if (token==\047A\047) { cfgl_lookup_int(cst,v); }\n"
"  else cfgl_error(\042a number token or constant was expected\042);\n"
"  (*len)++;\n"
"  yylex();\n"
"}\n"
"\n"
"\n"
"static void* cfgl_array_grow(void *ptr, int *size, int *len, int esize)\n"
"{\n"
"  void **P= (void**) ptr;\n"
"  if (*len==*size) {\n"
"    if (!*size) {\n"
"      *size= 10;\n"
"      *P= calloc(1,*size * esize);\n"
"    } else {\n"
"      *size += *size/2;\n"
"      *P= realloc(*P, *size*esize);\n"
"      memset(*P + *len*esize, 0, (*size-*len)*esize);\n"
"    }\n"
"  }\n"
"  return (*P) + *len*esize;\n"
"}\n"
"\n"
"static void cfgl_parse_recarray\n"
"    (void **ptr, int *size, int *len, int esize, cfgl_field_t *fields)\n"
"{\n"
"  void *P;\n"
"  yylex();\n"
"  P= cfgl_array_grow(ptr, size, len, esize);\n"
"  if (token==\047{\047) {\n"
"    yylex();\n"
"    while(token!=\047}\047)\n"
"      cfgl_parse_field(P, fields);\n"
"    yylex();\n"
"  } else cfgl_parse_field(P, fields);\n"
"  (*len)++;\n"
"}\n"
"\n"
"\n"
"static void cfgl_parse_flo(double *ptr, char *given, cfgl_flocst_t *cst)\n"
"{\n"
"  yylex();\n"
"  if (token==\047I\047) { *ptr= ivalue; }\n"
"  else if (token==\047F\047) { *ptr= fvalue; }\n"
"  else if (token==\047A\047) { cfgl_lookup_flo(cst,ptr); }\n"
"  else cfgl_error(\042syntax error. expecting an floating point number\042);\n"
"  *given= 1;\n"
"  yylex();\n"
"}\n"
"\n"
"static void cfgl_parse_floarray\n"
"   (double **ptr, int *size, int *len, cfgl_flocst_t *cst)\n"
"{\n"
"  yylex();\n"
"  if (token==\047{\047) {\n"
"    yylex();\n"
"    while(token!=\047}\047) \n"
"      cfgl_put_flo(ptr, size, len, cst);\n"
"    yylex();\n"
"  } else cfgl_put_flo(ptr, size, len,cst);\n"
"}\n"
"\n"
"static void cfgl_put_flo\n"
"  (double **ptr, int *size, int *len, cfgl_flocst_t *cst)\n"
"{\n"
"  double *v;\n"
"  if (token==\047}\047) return ;\n"
"  v= cfgl_array_grow(ptr, size, len, sizeof(double));\n"
"  if (token==\047I\047)      { *v= ivalue; } \n"
"  else if (token==\047F\047) { *v= fvalue; }\n"
"  else if (token==\047A\047) { cfgl_lookup_flo(cst,v); }\n"
"  else cfgl_error(\042a number token or constant was expected\042);\n"
"  (*len)++;\n"
"  yylex();\n"
"}\n"
"\n"
"static void cfgl_parse_str(char** ptr, char *given, cfgl_strcst_t *cst)\n"
"{\n"
"  yylex();\n"
"  if (token==\047S\047) { *ptr= strdup(sbuf); }\n"
"  else if (token==\047A\047) { cfgl_lookup_str(cst,ptr); }\n"
"  else cfgl_error(\042syntax error. expecting a string value\042);\n"
"  *given= 1;\n"
"  yylex();\n"
"}\n"
"\n"
"static void cfgl_parse_strarray\n"
"   (char ***ptr, int *size, int *len, cfgl_strcst_t *cst)\n"
"{\n"
"  yylex();\n"
"  if (token==\047{\047) {\n"
"    yylex();\n"
"    while(token!=\047}\047) \n"
"      cfgl_put_str(ptr, size, len, cst);\n"
"    yylex();\n"
"  } else cfgl_put_str(ptr, size, len,cst);\n"
"}\n"
"\n"
"static void cfgl_put_str\n"
"  (char ***ptr, int *size, int *len, cfgl_strcst_t *cst)\n"
"{\n"
"  char** v;\n"
"  if (token==\047}\047) return ;\n"
"  v= cfgl_array_grow(ptr, size, len, sizeof(char*));\n"
"  if (token==\047S\047)      { *v= strdup(sbuf); } \n"
"  else if (token==\047A\047) { cfgl_lookup_str(cst,v); }\n"
"  else cfgl_error(\042a string value or constant was expected\042);\n"
"  (*len)++;\n"
"  yylex();\n"
"}\n"
"\n"
"\n"
"static void cfgl_error(char *fmt, ...)\n"
"{\n"
"  char eb[2000];\n"
"  va_list ap;\n"
"  va_start(ap, fmt);\n"
"  vsnprintf(eb,2000,fmt,ap);\n"
"  va_end(ap);\n"
"  snprintf(cfgl_ebuf,2000, \042error %s:%d:%s\134n\042, cfgl_fname, yylineno, eb);\n"
"  longjmp(cfgl_elabel, 1);\n"
"}\n"
"\n"
"\n"
"static void sreset() { slen= 0; if (!sbuf) sbuf=malloc(ssize+1); }\n"
"static void sput(int x) { \n"
"  if (slen==ssize) {\n"
"    ssize+= ssize/2;\n"
"    sbuf= realloc(sbuf, ssize+1);\n"
"  }\n"
"  sbuf[slen++]= x;\n"
"}\n"
"\n"
"static char* cfgl_write_top(char *fn,void *ptr, cfgl_field_t *fields)\n"
"{\n"
"  FILE *f;\n"
"  f= fopen(fn,\042w\042);\n"
"  if (!f) {\n"
"    snprintf(cfgl_ebuf,sizeof(cfgl_ebuf)-1, \042can\047t open \047%s\047\134n\042, fn); \n"
"    return cfgl_ebuf;\n"
"  }\n"
"  cfgl_fname= fn;\n"
"  if (setjmp(cfgl_elabel)) \n"
"     return cfgl_ebuf;\n"
"\n"
"  \n"
"  while(fields->name)\n"
"  {\n"
"    cfgl_write_field(f, ptr, fields);\n"
"    fields++;\n"
"  }\n"
"\n"
"  fclose(f);\n"
"  return NULL;\n"
"}\n"
"\n"
"static void cfgl_write_field(FILE *out, void *ptr, cfgl_field_t *field)\n"
"{\n"
"  char *given;\n"
"  int  *N;\n"
"  char *dptr;\n"
"\n"
"  given= ptr + field->goffset;\n"
"  N= (int*) (ptr+field->noffset);\n"
"\n"
"    /* Note that the \047given\047 field isn\047t used for \047r\047 type entries.\n"
"       Each element of a record has its own \047given\047 field. We need\n"
"       to check those individually in order to decide whether an \n"
"       r-type entry has any meaningful data and needs to be written. */\n"
"  switch(field->kind)\n"
"  {\n"
"  case \047i\047: case \047f\047: case \047s\047: \n"
"    if (!given[0]) return ;\n"
"    break;\n"
"  case \047I\047: case \047F\047: case \047S\047: case \047R\047:\n"
"    if (!N[0]) return;\n"
"    break;\n"
"  case \047r\047:\n"
"    if (has_valid_fields(ptr+field->offset, field->arg))\n"
"    {\n"
"       print_spaces(out);\n"
"       fprintf(out, \042%s {\134n\042, field->name);\n"
"       spaces+= 3;\n"
"       cfgl_write_struct(out, ptr+field->offset, field->arg);\n"
"       spaces-= 3;\n"
"       fprintf(out, \042}\134n\042);\n"
"    }\n"
"    return ;\n"
"  default:\n"
"     return ;\n"
"  }\n"
"\n"
"  dptr= (char*) ptr + field->offset;\n"
"  switch(field->kind)\n"
"  {\n"
"  case \047i\047:\n"
"     print_spaces(out);\n"
"     fprintf(out, \042%s %d\134n\042, field->name, *(int*)dptr);\n"
"     return;\n"
"  case \047f\047:\n"
"     print_spaces(out);\n"
"     fprintf(out, \042%s %f\134n\042, field->name, *(double*)dptr);\n"
"     return;\n"
"  case \047s\047:\n"
"     print_spaces(out);\n"
"     fprintf(out, \042%s \042, field->name);\n"
"     cfgl_write_str(out, *(void**)dptr);\n"
"     fprintf(out, \042\134n\042);\n"
"     return ;\n"
"  }\n"
"\n"
"  int i; void *eptr;\n"
"  eptr= *(void**) dptr;\n"
"\n"
"  for(i=0;i<N[0];i++)\n"
"  {\n"
"    print_spaces(out);\n"
"    switch(field->kind)\n"
"    {\n"
"    case \047I\047:\n"
"      fprintf(out, \042%s %d\134n\042, field->name, *(int*)eptr);\n"
"      eptr+= sizeof(int);\n"
"      break;\n"
"    case \047F\047:\n"
"      fprintf(out, \042%s %f\134n\042, field->name, *(double*)eptr);\n"
"      eptr+= sizeof(double);\n"
"      break;\n"
"    case \047S\047:\n"
"      fprintf(out,\042%s \042, field->name);\n"
"      cfgl_write_str(out, *(void**)dptr);\n"
"      fprintf(out, \042\134n\042);\n"
"      eptr+= sizeof(char*);\n"
"      break;\n"
"    case \047R\047:\n"
"      if (has_valid_fields(eptr, field->arg))\n"
"      {\n"
"        fprintf(out, \042%s {\134n\042, field->name);\n"
"        spaces+= 3;\n"
"        cfgl_write_struct(out, eptr, field->arg);\n"
"        spaces-= 3;\n"
"        fprintf(out, \042}\134n\042 );\n"
"      }\n"
"      eptr+= field->eltsize;\n"
"      break;\n"
"    }\n"
"  }\n"
"}\n"
"\n"
"static int has_valid_fields(void *ptr, cfgl_field_t* field)\n"
"{\n"
"  int i;\n"
"  int N;\n"
"  void *eptr; \n"
"\n"
"  while(field->name)\n"
"  {\n"
"    switch(field->kind)\n"
"    {\n"
"      case \047i\047: case \047f\047: case \047s\047:\n"
"        if (*(char*)(ptr + field->goffset))  return 1;\n"
"        break;\n"
"      case \047I\047: case \047F\047: case \047S\047: \n"
"        if (*(int*)(ptr + field->noffset))  return 1;\n"
"        break;\n"
"      case \047r\047:\n"
"        if (has_valid_fields(ptr+field->offset, field->arg))\n"
"           return 1;\n"
"        break;\n"
"      case \047R\047:\n"
"        N= *(int*)(ptr+field->noffset);\n"
"        if (N==0) break;\n"
"        eptr= *(void**)(ptr+field->offset);\n"
"        for(i=0;i<N;i++)\n"
"        {\n"
"          if (has_valid_fields(eptr, field->arg)) return 1;\n"
"          eptr+= field->eltsize;\n"
"        }\n"
"        break;\n"
"    }\n"
"    field++;\n"
"  }\n"
"  return 0;\n"
"}\n"
"\n"
"static void cfgl_write_struct(FILE *f, void *ptr, cfgl_field_t *field)\n"
"{\n"
"  while(field->name)\n"
"  {\n"
"    cfgl_write_field(f, ptr, field);\n"
"    field++;\n"
"  }\n"
"}\n"
"\n"
"static void cfgl_write_str(FILE *f, char *str)\n"
"{\n"
"  if (!str) str= \042\042;\n"
"  fprintf(f,\042\134\042\042);\n"
"  while(*str)\n"
"  {\n"
"    unsigned char K= *str;\n"
"    if (K<32 || K>126) fprintf(f,\042\134\134%03o\042, K);\n"
"                  else fprintf(f,\042%c\042,K);\n"
"    str++;\n"
"  }\n"
"  fprintf(f,\042\134\042\042);\n"
"}\n"
"\n"
"static void print_spaces(FILE *out)\n"
"{\n"
"  int i;\n"
"  for(i=0;i<spaces;i++) fprintf(out,\042 \042);\n"
"}\n"
"\n"

  ;

